# -*- coding: utf-8 -*-
# Generated by Django 1.9.13 on 2017-09-05 23:22
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import morango.crypto
import morango.utils.uuids


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Buffer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('profile', models.CharField(max_length=40)),
                ('serialized', models.TextField(blank=True)),
                ('deleted', models.BooleanField(default=False)),
                ('last_saved_instance', morango.utils.uuids.UUIDField()),
                ('last_saved_counter', models.IntegerField()),
                ('partition', models.TextField()),
                ('source_id', models.CharField(max_length=96)),
                ('model_name', models.CharField(max_length=40)),
                ('conflicting_serialized_data', models.TextField(blank=True)),
                ('model_uuid', morango.utils.uuids.UUIDField()),
            ],
        ),
        migrations.CreateModel(
            name='Certificate',
            fields=[
                ('id', morango.utils.uuids.UUIDField(editable=False, primary_key=True, serialize=False)),
                ('profile', models.CharField(max_length=20)),
                ('scope_version', models.IntegerField()),
                ('scope_params', models.TextField()),
                ('public_key', morango.crypto.PublicKeyField()),
                ('salt', models.CharField(blank=True, max_length=32)),
                ('serialized', models.TextField()),
                ('signature', models.TextField()),
                ('_private_key', morango.crypto.PrivateKeyField(blank=True, db_column='private_key', null=True)),
                ('lft', models.PositiveIntegerField(db_index=True, editable=False)),
                ('rght', models.PositiveIntegerField(db_index=True, editable=False)),
                ('tree_id', models.PositiveIntegerField(db_index=True, editable=False)),
                ('level', models.PositiveIntegerField(db_index=True, editable=False)),
                ('parent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='morango.Certificate')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DatabaseIDModel',
            fields=[
                ('id', morango.utils.uuids.UUIDField(editable=False, primary_key=True, serialize=False)),
                ('current', models.BooleanField(default=True)),
                ('date_generated', models.DateTimeField(default=django.utils.timezone.now)),
                ('initial_instance_id', models.CharField(blank=True, max_length=32)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DatabaseMaxCounter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('instance_id', morango.utils.uuids.UUIDField()),
                ('counter', models.IntegerField()),
                ('partition', models.CharField(default=b'', max_length=128)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DeletedModels',
            fields=[
                ('id', morango.utils.uuids.UUIDField(primary_key=True, serialize=False)),
                ('profile', models.CharField(max_length=40)),
            ],
        ),
        migrations.CreateModel(
            name='InstanceIDModel',
            fields=[
                ('id', morango.utils.uuids.UUIDField(editable=False, primary_key=True, serialize=False)),
                ('platform', models.TextField()),
                ('hostname', models.TextField()),
                ('sysversion', models.TextField()),
                ('macaddress', models.CharField(blank=True, max_length=20)),
                ('counter', models.IntegerField(default=0)),
                ('current', models.BooleanField(default=True)),
                ('db_path', models.CharField(max_length=1000)),
                ('system_id', models.CharField(blank=True, max_length=100)),
                ('database', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.DatabaseIDModel')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Nonce',
            fields=[
                ('id', morango.utils.uuids.UUIDField(editable=False, primary_key=True, serialize=False)),
                ('timestamp', models.DateTimeField(default=django.utils.timezone.now)),
                ('ip', models.CharField(blank=True, max_length=100)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='RecordMaxCounter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('instance_id', morango.utils.uuids.UUIDField()),
                ('counter', models.IntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='RecordMaxCounterBuffer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('instance_id', morango.utils.uuids.UUIDField()),
                ('counter', models.IntegerField()),
                ('model_uuid', morango.utils.uuids.UUIDField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ScopeDefinition',
            fields=[
                ('id', models.CharField(max_length=20, primary_key=True, serialize=False)),
                ('profile', models.CharField(max_length=20)),
                ('version', models.IntegerField()),
                ('primary_scope_param_key', models.CharField(blank=True, max_length=20)),
                ('description', models.TextField()),
                ('read_filter_template', models.TextField()),
                ('write_filter_template', models.TextField()),
                ('read_write_filter_template', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='Store',
            fields=[
                ('profile', models.CharField(max_length=40)),
                ('serialized', models.TextField(blank=True)),
                ('deleted', models.BooleanField(default=False)),
                ('last_saved_instance', morango.utils.uuids.UUIDField()),
                ('last_saved_counter', models.IntegerField()),
                ('partition', models.TextField()),
                ('source_id', models.CharField(max_length=96)),
                ('model_name', models.CharField(max_length=40)),
                ('conflicting_serialized_data', models.TextField(blank=True)),
                ('id', morango.utils.uuids.UUIDField(primary_key=True, serialize=False)),
                ('dirty_bit', models.BooleanField(default=False)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SyncSession',
            fields=[
                ('id', morango.utils.uuids.UUIDField(primary_key=True, serialize=False)),
                ('start_timestamp', models.DateTimeField(default=django.utils.timezone.now)),
                ('last_activity_timestamp', models.DateTimeField(blank=True)),
                ('active', models.BooleanField(default=True)),
                ('is_server', models.BooleanField(default=False)),
                ('profile', models.CharField(max_length=40)),
                ('connection_kind', models.CharField(choices=[('network', 'Network'), ('disk', 'Disk')], max_length=10)),
                ('connection_path', models.CharField(max_length=1000)),
                ('local_ip', models.CharField(blank=True, max_length=100)),
                ('remote_ip', models.CharField(blank=True, max_length=100)),
                ('local_instance', models.TextField(default='{}')),
                ('remote_instance', models.TextField(default='{}')),
                ('local_certificate', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='syncsessions_local', to='morango.Certificate')),
                ('remote_certificate', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='syncsessions_remote', to='morango.Certificate')),
            ],
        ),
        migrations.CreateModel(
            name='TransferSession',
            fields=[
                ('id', morango.utils.uuids.UUIDField(primary_key=True, serialize=False)),
                ('filter', models.TextField()),
                ('incoming', models.BooleanField()),
                ('active', models.BooleanField(default=True)),
                ('records_transferred', models.IntegerField(default=0)),
                ('records_total', models.IntegerField(blank=True, null=True)),
                ('start_timestamp', models.DateTimeField(default=django.utils.timezone.now)),
                ('last_activity_timestamp', models.DateTimeField(blank=True)),
                ('sync_session', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.SyncSession')),
            ],
        ),
        migrations.AddField(
            model_name='recordmaxcounterbuffer',
            name='transfer_session',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.TransferSession'),
        ),
        migrations.AddField(
            model_name='recordmaxcounter',
            name='store_model',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.Store'),
        ),
        migrations.AddField(
            model_name='certificate',
            name='scope_definition',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.ScopeDefinition'),
        ),
        migrations.AddField(
            model_name='buffer',
            name='transfer_session',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='morango.TransferSession'),
        ),
        migrations.AlterUniqueTogether(
            name='recordmaxcounter',
            unique_together=set([('store_model', 'instance_id')]),
        ),
        migrations.AlterUniqueTogether(
            name='buffer',
            unique_together=set([('transfer_session', 'model_uuid')]),
        ),
    ]
